rps_admin_interface/apps/views/views_group_users.py
from flask import current_app, Blueprint, request, render_template, url_for, send_file, Response
import pandas as pd
import io
import tempfile

gu_bp = Blueprint(
    'group_users_blueprint',
    __name__,
    url_prefix="",
    template_folder='/templates',
    static_folder='/static', static_url_path='/assets'
)

@gu_bp.route('/list-group-users', methods=['GET','POST'])
def index():
    if request.method == 'GET':
        keycloak_bridge = current_app.config["KEYCLOAK_BRIDGE"]
        groups = keycloak_bridge.get_groups(ignore_members=True)

        return render_template('home/list-group-users.html', 
                        title="List Groups' Users",
                        groups=groups)

@gu_bp.route('/api-list-group-users', methods=['POST'])
def api_list_group_users():
    if request.method == 'POST':
        data = request.get_json()
        # For showing in interface so the admin can check the users that are to be imported
        keycloak_bridge = current_app.config["KEYCLOAK_BRIDGE"]

        index_dict = {}
        index = 0
        group_members = []

        # Get all users in groups
        for groupname in data["groups"]:
            group = keycloak_bridge.get_group_by_name(groupname)
            for member in group.members:
                if member not in group_members:
                    member.add_group(groupname)
                    group_members.append(member)
                    
                    index_dict[member.username] = index
                    index += 1
                else:
                    # some members can be at other groups selected
                    group_members[index_dict[member.username]].add_group(groupname)

        # Change groups member to dictionary instead of User Object
        group_members = [dict(member) for member in group_members]

        ## Context
        # Flex table headers
        flex_table_headers = {
            "email": "Email",
            "username": "Username",
            "keycloak_id": "ID",
            "first_name": "First Name",
            "last_name": "Last Name",
            "groups": "Groups"
        }

        download_id = "download-group-users"
        # api_download_group_users
        api_download = url_for('group_users_blueprint.api_download_group_users')

        context = {
            "html": render_template('includes/flex-table.html',
                            table_id="group-users-table",
                            download_id=download_id,
                            api_download=api_download,
                            flex_table_headers=flex_table_headers,
                            users=group_members),
            "flex_table_headers": flex_table_headers,
            "data": group_members
        }

        return context
    
@gu_bp.route('/api-download-group-users', methods=['POST'])
def api_download_group_users():
    if request.method == 'POST':
        data = request.get_json()

        df = pd.DataFrame(data["data"])

        excel_data = io.BytesIO()
        writer = pd.ExcelWriter(excel_data, engine='xlsxwriter')
        df.to_excel(writer, sheet_name='Sheet1')
        writer.save()
        excel_data.seek(0)

        # Set the Content-Type header to the appropriate MIME type
        EXCELMIME="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
        response = send_file(excel_data, download_name='data.xlsx', as_attachment=True, 
                         mimetype=EXCELMIME)
        # Return the Excel file to the user for download
        return response
    

rps_admin_interface/apps/views/views_home.py
from flask import Blueprint, current_app, render_template

home_bp = Blueprint(
    'home_blueprint', 
    __name__,
    url_prefix="",
    template_folder='/templates',
    static_folder='/static', static_url_path='/assets'
)

@home_bp.route('/')
def index():
    keycloak_bridge = current_app.config["KEYCLOAK_BRIDGE"]

    version = current_app.config["VERSION"]

    registered_users = keycloak_bridge.get_new_users()
    
    users = []
    for user in registered_users:
        if not "approved" in user.roles:
            if user.enabled:
                users.append(user)
            
    pending = len(users)
    
    keycloak_url = current_app.config["KEYCLOAK_URL"]
    keycloak_realm = current_app.config["KEYCLOAK_REALM"]
    keycloak_console_url = f"{keycloak_url}/admin/{keycloak_realm}/console"
    
    return render_template('home/index.html', pending=pending, version=version, keycloak_console_url=keycloak_console_url)

rps_admin_interface/apps/views/views_users_export.py
from flask import flash,redirect, current_app, Blueprint, request, jsonify, render_template, send_from_directory, send_file, Response
from pathlib import Path
from rps_admin_cli.tools import export_users
import os
from ..scripts.import_users import read_imported_users, import_users
from pathlib import Path
from datetime import datetime
from threading import Thread



ur_bp = Blueprint(
    'users_export_blueprint', 
    __name__,
    url_prefix="",
    template_folder='/templates',
    static_folder='/static', static_url_path='/assets'
)

@ur_bp.route('/export-users', methods=['GET'])
def index():
    export_running = export_thread.is_alive()
    timestamp = get_export_file('./exports')
    if request.method == 'GET':
        return render_template('home/export-users.html', 
                        title="Export Users",
                        timestamp=timestamp,
                        export_running=export_running)

@ur_bp.route("/generate-user-export" , methods = ["POST"] ) 
def gen_export():
        
        run_export_on_thread()
        return redirect("/export-users")


@ur_bp.route("/download-user-export" , methods = ["GET"] ) 
def download_export():
        csv = load_export('./exports/export.csv')
        return Response(
                csv,
                mimetype="text/csv",
                headers={"Content-disposition":
                        "attachment; filename=export.csv"})

def generate_export():
    csv = export_users(verbose = False, as_string = True) 
    save_export('./exports/export.csv', csv)

export_thread:Thread = Thread(target=generate_export, name='export-gen-thread')
def run_export_on_thread():
    global export_thread
    if export_thread.is_alive():
        return
    export_thread = Thread(target=generate_export, name='export-gen-thread')
    export_thread.start()




def check_folder(path:str):
    folder = Path(path)
    if not folder.exists():
        return False
    
    if not folder.is_dir():
        return False
    
    return True
    

def get_export_file(path:str):
    folder = Path(path)
    if not check_folder(path):
        folder.mkdir()
        return []
    
    file = Path(f"{path}/export.csv")
    
    if not file.exists():
        return None
    
    meta_data = file.stat()
    
    timestamp = datetime.fromtimestamp(meta_data.st_atime).strftime('%Y-%m-%d %H:%M:%S')
    
    return timestamp
    
def save_export(path:str, content):
    file = Path(path)
    file.touch()
    file.write_text(content)
    
def load_export(path:str):
    file = Path(path)
    if not file.exists():
        return ""
    
    return file.read_text()

rps_admin_interface/apps/views/views_users_import.py
from flask import flash, current_app, Blueprint, request, jsonify, render_template, send_from_directory, send_file
from pathlib import Path
import os

from ..scripts.import_users import read_imported_users, import_users

ui_bp = Blueprint(
    'users_import_blueprint', 
    __name__,
    url_prefix="",
    template_folder='/templates',
    static_folder='/static', static_url_path='/assets'
)

@ui_bp.route('/import-users', methods=['GET','POST'])
def index():
    api_download = ui_bp.name + ".api_download_users_example"
    api_show = ui_bp.name + ".index"

    if request.method == 'GET':
        return render_template('home/import-users.html', 
                        title="Import Users",
                        data=[],
                        api_download=api_download, api_show=api_show)
    
    elif request.method == 'POST':
        # Show imported excel file
        file = request.files['file']

        # For showing in interface so the admin can check the users that are to be imported
        users_list, users_info = read_imported_users(file=file, config=current_app.config)

        import_allowed = all([user["user_valid"] for user in users_info])

        # roles = ["loks-l", "loks-m", "groups-management", "napkon", "num-portal-access"]
        
        # If no users are found in the file, show error message
        if not users_list:
            flash("No data found in file", 'danger')
            return render_template('home/import-users.html',
                                   data=[],
                                   api_show=api_show)

        return render_template('home/import-users.html', 
                               title="Import Users",
                               api_show=api_show,
                               file=file,
                               data=users_list,
                               users_info=users_info,
                            #    roles=roles,
                               import_allowed=import_allowed)

@ui_bp.route('/import-users/submit', methods=['POST'])
def api_submit_users():
    if request.method == "POST":

        data = request.get_json()
        if not data:
            return
        
        imported_users_list = data.get('user', [])

        if not imported_users_list:
            return

        overwrite = data.get('overwrite', False)

        print("Importing Users")
        import_users(imported_users_list, overwrite)

        return jsonify({"message": "success"})

rps_admin_interface/apps/templates/home/export-users.html
{% extends "layouts/base.html" %}

{% block title %}
{{ title }}
{% endblock %}

{% block content %}
    <div class="container d-flex">
        <a class="btn btn btn-outline-secondary mb-2" href="/">←</a>
        {% if export_running %}
            <p> Generating export please be patient. </p>
        {% else %}
            <form action="/generate-user-export" method="post">
            <button onclick = "button()" type="submit" formmethod="post" class="btn btn btn-outline-primary mb-2">Generate</button>
                <span style = "display: none" id = "loading" class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
            </form>
        {% endif %}
        {% if timestamp %}
            <a class="btn btn btn-outline-secondary mb-2" href="/download-user-export">Download latest - {{timestamp}}</a>
        {% endif %}
    </div>
{% endblock %}

{% block javascripts %}
<script>
    function button(){
        const loadingbar = $("#loading")
        loadingbar.show()
    }
</script>
{% endblock %}

rps_admin_interface/apps/templates/home/import-users.html
{% extends "layouts/base.html" %}

{% block title %}
	{{ title }}
{% endblock %}

{% block content %}
    <a class="btn btn btn-outline-secondary mb-2" href="/">←</a>
	{% include 'includes/upload.html' %}
    
	{% if data %}
        <hr>
        
        <!-- Buttons and Alert Messages -->
        {% if import_allowed %}
        <div class="container-fluid d-flex justify-content-end" id="Actions">
        <div class="form-check my-auto">
            <input class="form-check-input" type="checkbox" value="" id="overwriteUsers"  data-bs-toggle="tooltip" data-bs-placement="top" 
            data-bs-title="If you enable this option all of the users data will be overwritten (including attributes).
             If this is not checked only new Groups/Roles/Attributes will be added">
            <label class="form-check-label" for="overwriteUsers">
                Overwrite user
            </label>
        </div>
        <div id="import-button" class="d-flex justify-content-end m-2">
            <button type="button" id="submitUsers" class="btn btn-success">Import Users</button>

            <div id="importing" class="spinner-grow text-primary mb-1" role="status">
                <span class="visually-hidden">Loading...</span>
            </div>
        </div>
        </div>
        {% else %}
        <div class="alert alert-danger m-2 mb-3" role="alert">
            <i class="fa-solid fa-circle-exclamation me-2"></i>
            Some imported users are not valid! Please fix it!
        </div>
        {% endif %}


        <!-- All roles are picked Message? -->
        <div id="group-radio-message" class="alert alert-warning m-2 mb-3" role="alert">
            <i class="fa-solid fa-circle-exclamation me-2"></i>
            Please pick a group for each user!
        </div>

        <!-- Imporint Users Successful! -->
        <div id="importing-success" class="alert alert-success m-2 mb-3" role="alert">
            <i class="fa-solid fa-circle-exclamation me-2"></i>
            Importing Users Successful!
        </div>
        <!--  -->
        
        <!-- Accordion for the imported users -->
        <div class="accordion accordion-flush" id="accordion-users">
            {% for member in data %}
                <!-- Set the index of the user for easy usage -->
                {% set user_index = loop.index - 1  %}
                <div class="accordion-item">
                    <!-- Set the variables from the user info dictionary for easy usage -->
                    {% set user_valid = users_info[loop.index - 1]['user_valid']  %}
                    {% set user_update = users_info[loop.index - 1]['user_update']  %}
                    {% set username_valid = users_info[loop.index - 1]['username_valid']  %}
                    {% set email_valid = users_info[loop.index - 1]['email_valid']  %}

                    <!-- Accordion Header where it shows username and emails with importing status -->
                    <h2 class="accordion-header" id="heading-{{ user_index }}">
                        <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" 
                                data-bs-target="#collapse-{{ user_index }}" aria-expanded="false" 
                                aria-controls="collapse-{{ user_index }}">
                            {{ member.email }} - {{ member.username }}
                            <!-- Whether User is valid or invalid -->
                            {% if user_valid and user_update %}
                                <!-- User already exists and is valid -->
                                <i class="mx-2 fa-regular fa-pen-to-square" style="color: #fcc419;"
                                   data-bs-toggle="tooltip" data-bs-placement="top" 
                                   title="User already exist. Updating user!"></i>
                            {% elif user_valid %}
                                <!-- New Username and Email Valid! -->
                                <i class="mx-2 fa-check fa-solid" style="color: green;"></i>
                            {% else %}
                                <span class="mx-2">
                                    <!-- Username or Email or Groups Invalid! -->
                                    {% if username_valid == False %}
                                        <i class="mx-1 fa-solid fa-user" style="color: red;" 
                                        data-bs-toggle="tooltip" data-bs-placement="top" title="Username is already taken!"></i>
                                    {% endif %}

                                    {% if email_valid == False %}
                                        <i class="mx-1 fa-solid fa-envelope" style="color: red;"
                                        data-bs-toggle="tooltip" data-bs-placement="top" title="Email is already taken!"></i>
                                    {% endif %}
                                </span>

                            {% endif %}
                        </button>
                    </h2>

                    <!-- Accordion Body where it shows the user info -->
                    <div id="collapse-{{ user_index }}" class="accordion-collapse collapse" 
                            aria-labelledby="heading-{{ user_index }}" data-bs-parent="#accordion-users">
                        <div class="card">
                            <!-- Display the dictionary contents in a table -->
                            <div class="card-body">
                                <table class="table-sm">
                                    {% for key, value in member.items() %}
                                        <tr>
                                            <!-- Username and Email Identity --> 
                                            {% if key == "username" or key == "email" %}
                                                <td>{{ key }}:</td>
                                                <td>
                                                    {% if user_valid %}
                                                        <span>{{ value }}</span>
                                                    {% else %}
                                                        {% if (username_valid == False and key == "username") or (email_valid == False and key == "email")  %}
                                                            <span>{{ value }}</span><i class="mx-1 fa-solid fa-circle-exclamation" style="color: red;"></i>
                                                        {% else %}
                                                            <span>{{ value }}</span>
                                                        {% endif %}
                                                    {% endif %}
                                                </td>
                                                
                                            {% elif key == "attributes" %}
                                                <td>{{ key }}:</td>
                                                {% with items=value %}
                                                    {% include 'includes/simple-table.html' %}
                                                {% endwith %}
                                            {% elif key != "groups" and key != "roles" %}
                                                <td>{{ key }}:</td>
                                                <td>{{ value }}</td>
                                            {% endif %}
                                        </tr>
                                    {% endfor %}
                                        <tr>
                                            <td>groups:</td>
                                            <td>
                                                <!-- Groups -->
                                                <div class="form-check form-check-inline" id="group-{{user_index}}-groups">
                                                    {% for group in member.groups %}
                                                    <div class="form-check form-check-inline">
                                                        {% set group_index = loop.index - 1 %}
                                                        <input class="form-check-input role-radio" checked type="checkbox" name="{{group}}" value="{{group}}" id="group-{{group_index}}-{{user_index}}">
                                                        <label class="form-check-label" for="group-{{group_index}}-{{user_index}}">
                                                            {{group}}
                                                        </label>
                                                    </div>
                                                    {% endfor %}
                                                </div>
                                            </td>
                                        </tr>
                                        {% if roles %}
                                        <tr>
                                            <td>roles:</td>
                                            <td>
                                                <!-- Roles -->
                                                <div id="group-{{user_index}}-roles">
                                                {% for role in roles %}
                                                    {% set role_index = loop.index - 1 %}
                                                    <div class="form-check form-check-inline">
                                                        <input class="form-check-input role-radio" checked type="checkbox" name="{{role}}" value="{{role}}" id="role-{{role_index}}-{{user_index}}">
                                                        <label class="form-check-label" for="role-{{role_index}}-{{user_index}}">
                                                            {{role}}
                                                        </label>
                                                    </div>
                                                    {% endfor %}
                                                </div>
                                            </td>
                                        </tr>
                                        {% endif %}
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            {% endfor %}
        </div>
        <!--  -->
	{% endif %}
{% endblock %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}
<script>
    // Hide the importing and importing success messages
    $("#importing").hide()
    $("#importing-success").hide()

    // Make sure each user has group selected before enabling the importing users
    // let submitButton = $('#submitUsers');
    // Disable the button initially
    // submitButton.prop('disabled', true);

    /*$('#accordion-users').on('change', 'input[type="checkbox"]', function() {
        let importedUsers = {{ data | tojson }};
        let allRowsSelected = true;

        // Iterate over each row and check if a radio button is selected
        for (let i = 0; i < importedUsers.length; i++) {
            let group = $("input[name='group-" + i +"']:checked").val();
            if (group == undefined) {
                allRowsSelected = false;
                break; // Break out of the loop if a row is not selected
            }
        }
        if (allRowsSelected) { $("#group-radio-message").hide()}
        // Enable or disable the button based on whether all rows have a selected radio button
        submitButton.prop('disabled', !allRowsSelected);
    }); 
    */

    // For importing new users!
    $("#submitUsers").click( function(event) {
        let importedUsers = {{ data | tojson }}

        // check what group is selected for each user
        for (let i = 0; i < importedUsers.length; i++) {
            var selected = [];
            $('#group-'+ i + '-groups input:checked').each(function() {
                selected.push($(this).attr('name'));
            });
            importedUsers[i].groups = selected;
        }
        
        // check what roles is selected for each user
        for (let i = 0; i < importedUsers.length; i++) {
            var selected = [];
            $('#roles-'+ i + '-roles input:checked').each(function() {
                selected.push($(this).attr('name'));
            });
            importedUsers[i].roles = selected
        }
        
        $("#Actions").hide()
        $("#importing").show()

        $.ajax({
            type: "POST",
            url: "{{ url_for('users_import_blueprint.api_submit_users') }}",
            data: JSON.stringify({user: importedUsers, overwrite: $('#overwriteUsers')[0].checked}),
            processData: false,
            contentType: 'application/json',
            success: function(response) {
                $("#importing").hide()
                $("#import-button").hide()
                $("#importing-success").show()
            },
            error: function(error) {
                console.log(error.responseText)
                alert("Something went wrong check your Browser-Console for more information")
            }
        })
    })

    // Enable Tooltips
    var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
    var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
        return new bootstrap.Tooltip(tooltipTriggerEl)
    })
</script>


{% if config['DEBUG'] == True %}
<p>{{data}}</p>
{% endif %}

{% endblock javascripts %}

rps_admin_interface/apps/templates/home/index.html
{% extends "layouts/base.html" %}

{% block title %}
Homepage
{% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}
<link href="{{ config.ASSETS_ROOT }}/css/home/style.css" rel="stylesheet"/>
{% endblock stylesheets %}

{% block content %}
<div class="row">


    <div class="col-md-4 col-sm-6 mb-3">
        <a href="{{ url_for('users_registration_review_blueprint.index') }}" class="card-link">
            <div class="card">
                <div class="rounded d-flex align-items-center justify-content-between p-4">
                    <div class="ms-0">
                        <h5 class="card-title mb-1">Review User Registration</h5>
                        <span class="card-subtitle"> <span class="badge bg-success">{{ pending }}</span> Users Registration Pending     </span>
                    </div>
                    <i class="fa fa-user-plus fa-3x text-muted opacity-50"></i>
                </div>
            </div>
        </a>
    </div>
    <div class="col-md-4 col-sm-6 mb-3">
        <a href="{{ keycloak_console_url }}" class="card-link">
            <div class="card">
                <div class="rounded d-flex align-items-center justify-content-between p-4">
                    <div class="ms-0">
                        <h5 class="card-title mb-1">User Console</h5>
                        <span class="card-subtitle">Keycloak console for managing users directly in the database.</span>
                    </div>
                    <i class="fa fa-computer fa-3x text-muted opacity-50"></i>
                </div>
            </div>
        </a>
    </div>
    <div class="col-md-4 col-sm-6 mb-3">
        <a href="{{ url_for('users_export_blueprint.index') }}" class="card-link">
            <div class="card">
                <div class="rounded d-flex align-items-center justify-content-between p-4">
                    <div class="ms-0">
                        <h5 class="card-title mb-1">Export Users</h5>
                        <span class="card-subtitle">Export Keycloak Users to CSV</span>
                    </div>
                    <i class="fa fa-computer fa-3x text-muted opacity-50"></i>
                </div>
            </div>
        </a>
    </div>
    <div class="col-md-4 col-sm-6 mb-3">

        <a href="{{ url_for('users_import_blueprint.index') }}" class="card-link">
            <div class="card">
                <div class="rounded d-flex align-items-center justify-content-between p-4">
                    <div class="ms-0">
                        <h5 class="card-title mb-1">Import Users</h5>
                        <span class="card-subtitle">Add Users through importing excel file</span>
                    </div>
                    <i class="fa fa-cloud-arrow-up fa-3x text-muted opacity-50"></i>
                </div>
            </div>
        </a>

    </div>
    <!-- <div class="col-md-4 col-sm-6 mb-3">
        <a href="{{ url_for('home_blueprint.index') }}" class="card-link">
            <div class="card">
                <div class="rounded d-flex align-items-center justify-content-between p-4">
                    <div class="ms-0">
                        <h5 class="card-title mb-1">List New Registered Users</h5>
                        <span class="card-subtitle position-relative">List all new registered users in system</span>
                    </div>
                    <i class="fa fa-address-book fa-3x text-muted opacity-50"> </i>
                </div>
            </div>
        </a>
    </div>
    <div class="col-md-4 col-sm-6 mb-3">
        <a href="{{ url_for('group_users_blueprint.index') }}" class="card-link">
            <div class="card">
                <div class="rounded d-flex align-items-center justify-content-between p-4">
                    <div class="ms-0">
                        <h5 class="card-title mb-1">Find Groups Users</h5>
                        <span class="card-subtitle">Find users based on group/s then export them as excel file</span>
                    </div>
                     <i class="fa fa-magnifying-glass fa-3x text-muted opacity-50"></i>
                </div>
            </div>
        </a>
    </div> -->
</div>

<div>v{{version}}</div>

{% endblock content %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}{% endblock javascripts %}